#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> gr;

vector<int> st;
vector<int> t;
int timer = 0;
int cc = 0;
vector<int> comp_color;

void dfs(int v) {
    int tin = timer++;
    t[v] = tin;
    st.push_back(v);
    for (auto to : gr[v]) {
        if (t[to] == -1) {
            dfs(to);
            t[v] = min(t[v], t[to]);
        } else if (comp_color[to] == -1) {
            t[v] = min(t[v], t[to]);
        }
    }
    if (tin == t[v]) {
        while (st.back() != v) {
            comp_color[st.back()] = cc;
            st.pop_back();
        }
        comp_color[v] = cc;
        st.pop_back();
        cc++;
    }
}

void scc_colors() {
    st.clear();
    timer = 0;
    t.assign(gr.size(), -1);
    comp_color.assign(gr.size(), -1);
    for (int i = 0; i < gr.size(); ++i) {
        if (t[i] == -1) {
            dfs(i);
        }
    }
}

struct Limits {
    int max_n = 2'000;
    int max_m = 2'000;
    bool is_dag = false;
    bool is_scc = false;
    bool i_to_i_plus_1 = false;
    bool n_to_1 = false;
};

Limits LIMITS[] = {
    /* 0: */ {},
    /* 1: */ {.max_n = 14, .max_m = 14},
    /* 2: */ {.max_n = 20, .max_m = 20},
    /* 3: */ {.is_dag = true, .i_to_i_plus_1 = true},
    /* 4: */ {.is_dag = true},
    /* 5: */ {.is_scc = true, .i_to_i_plus_1 = true, .n_to_1 = true},
    /* 6: */ {.is_scc = true},
    /* 7: */ {},
};

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int group = stoi(validator.group());

    Limits limits = LIMITS[group];

    int n = inf.readInt(2, limits.max_n, "n");
    inf.readSpace();
    int m = inf.readInt(1, limits.max_m, "m");
    inf.readSpace();
    int g = inf.readInt(group, group, "g");
    inf.readEoln();

    set<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int u = inf.readInt(1, n, "u");
        inf.readSpace();
        int v = inf.readInt(1, n, "v");
        inf.readEoln();

        ensuref(u != v, "loops are not allowed");
        ensuref(!edges.count({u, v}) && !edges.count({v, u}), "multiple edges are not allowed");

        if (limits.is_dag) {
            ensuref(u < v, "edges cannot be directed from right to left in group %d", group);
        }

        edges.emplace(u, v);
    }

    inf.readEof();

    if (limits.i_to_i_plus_1) {
        for (int i = 1; i <= n - 1; ++i) {
            ensuref(edges.count({i, i + 1}), "(%d, %d) is not in graph in group %d", i, i + 1, group);
        }
    }

    if (limits.n_to_1) {
        ensuref(edges.count({n, 1}), "(%d, %d) is not in graph in group %d", n, 1, group);
    }

    if (limits.is_scc) {
        gr.resize(n);
        for (auto [u, v] : edges) {
            gr[u - 1].push_back(v - 1);
        }
        scc_colors();
        ensuref(count(comp_color.begin(), comp_color.end(), 0) == n, "graph is not strongly connected in group %d", group);
    }
}
