#include "bits/stdc++.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array

using namespace std;

using vi = vector<int>;
using ll = long long;
using vl = vector<ll>;

const int N = 2e3 + 5;
const int INFi = 2e9;

const int MOD = 1e9 + 7;
ll ans_cnt = 1;

namespace CompSplit {
    vector<pair<int, int>> g[N], gr[N];
    bool ban[N];
    int used[N];
    int comp[N];

    int T = 1;

    void dfs(int v) {
        used[v] = T;
        for (auto &[u, i]: g[v]) {
            if (ban[i] || used[u] == T) continue;
            dfs(u);
        }
    }

    int split_comp(int n) {
        vi ts;
        auto dfs1 = [&](auto &&self, int v) -> void {
            used[v] = T;
            for (auto &[u, i]: gr[v]) {
                if (used[u] == T) continue;
                self(self, u);
            }
            ts.push_back(v);
        };

        T++;
        for (int i = 1; i <= n; ++i) {
            if (used[i] != T) {
                dfs1(dfs1, i);
            }
        }
        reverse(all(ts));

        int c = 0;
        auto dfs2 = [&](auto &&self, int v) -> void {
            comp[v] = c;
            for (auto &[u, i]: g[v]) {
                if (comp[u]) continue;
                self(self, u);
            }
        };

        for (auto &v: ts) {
            if (comp[v]) continue;
            c++;
            dfs2(dfs2, v);
        }

        return c;
    }
};


int solve_comp(vector<vi> &gb) {
    if (gb.empty()) return 0;
    int n = gb.size();
    vector<vi> rgb(n);
    rep(i, n) {
        for (auto &j: gb[i]) {
            rgb[j].push_back(i);
        }
    }
    vi ts;
    vector<bool> was(n);
    auto dfs1 = [&](auto &&self, int v) -> void {
        was[v] = true;
        for (auto &u: rgb[v]) {
            if (was[u]) continue;
            self(self, u);
        }
        ts.push_back(v);
    };

    rep(i, n) {
        if (!was[i]) {
            dfs1(dfs1, i);
        }
    }
    reverse(all(ts));

    vector<int> cc(n);
    int c = 0;
    auto dfs2 = [&](auto &&self, int v) -> void {
        cc[v] = c;
        for (auto &u : gb[v]) {
            if (cc[u]) continue;
            self(self, u);
        }
    };

    for (auto &v: ts) {
        if (cc[v]) continue;
        c++;
        dfs2(dfs2, v);
    }

    rep(i, n) cc[i]--;
    vector<int> cnt_cc(c), have_less(c);
    rep(i, n) {
        cnt_cc[cc[i]]++;
        for(auto &j : gb[i]) {
            if (cc[j] != cc[i]) {
                assert(cc[j] < cc[i]);
                have_less[cc[i]] = 1;
            }
        }
    }
    int ans = 0;
    rep(i, c) {
        ans += cnt_cc[i];
        if (!have_less[i]) {
            ans_cnt *= cnt_cc[i];
            ans_cnt %= MOD;
            ans--;
        }
    }

    return ans;
}

struct SolverComp {
    vector<vector<pair<int, int>>> g, gr;
    vector<bool> ban;
    vector<int> used;

    int T = 1;
    int ans = 0;

    void dfs(int v) {
        used[v] = T;
        for (auto &[u, i]: g[v]) {
            if (ban[i] || used[u] == T) continue;
            dfs(u);
        }
    }

    SolverComp(int sz, vector<pair<int, int>> es) {
        g.resize(sz);
        gr.resize(sz);

        rep(i, es.size()) {
            auto [u, v] = es[i];
            g[u].emplace_back(v, i);
            gr[v].emplace_back(u, i);
        }
        ban.resize(es.size(), false);
        used.resize(sz, 0);

        int m = es.size();
        vector<bool> can(m);
        rep(i, m) {
            auto [u, v] = es[i];
            ban[i] = true;
            T++;
            dfs(u);
            ban[i] = false;
            if (used[v] == T) continue;
            can[i] = true;
        }

        int cnt_can = 0;
        vector<int> idx(m, -1);
        rep(i, m) {
            if (can[i]) {
                idx[i] = cnt_can++;
            }
        }
        vector<vi> gb(cnt_can + 1);
        rep(i, m) {
            if (!can[i]) continue;

            auto [u, v] = es[i];
            ban[i] = true;

            vector<int> d(sz, INFi);
            vector<pair<int, int>> p(sz, {-1, -1});
            deque<int> q;
            q.push_back(u);
            d[u] = 0;

            vector<bool> was(sz, false);
            while (!q.empty()) {
                int x = q.front();
                q.pop_front();
                if (was[x]) continue;
                was[x] = true;

                for (auto &[y, j]: g[x]) {
                    if (ban[j]) continue;
                    if (d[y] > d[x]) {
                        d[y] = d[x];
                        p[y] = {x, j};
                        q.push_front(y);
                    }
                }

                for (auto &[y, j]: gr[x]) {
                    if (ban[j] || !can[j]) continue;
                    if (d[y] > d[x] + 1) {
                        d[y] = d[x] + 1;
                        p[y] = {x, j};
                        q.push_back(y);
                    }
                }
            }

            ban[i] = false;

            if (d[v] == INFi) {
                gb[idx[i]].push_back(cnt_can);
                continue;
            }

            int t = v;
            while (t != u) {
                auto [pt, j] = p[t];
                if (d[t] == d[pt] + 1) {
                    assert(can[j]);
                    gb[idx[i]].emplace_back(idx[j]);
//                cerr << i << ' ' << j << endl;
                }
                t = pt;
            }
        }

        ans = solve_comp(gb);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    int t; cin >> t;

    vector<pair<int, int>> es;
    rep(i, m) {
        int u, v;
        cin >> u >> v;
        es.emplace_back(u, v);
        CompSplit::g[u].emplace_back(v, i);
        CompSplit::gr[v].emplace_back(u, i);
    }

    int c = CompSplit::split_comp(n);

    int ans = 0;

    for(int co = 1; co <= c; ++co) {
        int sz;
        vector<pair<int, int>> esc;
        {
            vi verts;
            for(int i = 1; i <= n; ++i) {
                if (CompSplit::comp[i] == co) {
                    verts.push_back(i);
                }
            }
            sort(all(verts));
            rep(i, m) {
                auto [u, v] = es[i];
                if (CompSplit::comp[u] == CompSplit::comp[v] && CompSplit::comp[v] == co) {
                    esc.emplace_back(lower_bound(all(verts), u) - verts.begin(), lower_bound(all(verts), v) - verts.begin());
                }
            }
            sz = verts.size();
        }

        SolverComp kek(sz, esc);
        ans += kek.ans;
    }


    map<pair<int, int>, int> cnt_change;
    rep(i, m) {
        auto [u, v] = es[i];
        if (CompSplit::comp[u] == CompSplit::comp[v]) continue;

        CompSplit::T++;
        CompSplit::ban[i] = true;
        CompSplit::dfs(u);

        if (CompSplit::used[v] == CompSplit::T) {
            ans++;
            cnt_change[{CompSplit::comp[u], CompSplit::comp[v]}]++;
        } else {
            CompSplit::ban[i] = false;
            pair<int, int> e = {CompSplit::comp[u], CompSplit::comp[v]};
            if (cnt_change.contains(e)) {
                ans_cnt *= (cnt_change[e] + 1);
                ans_cnt %= MOD;
            }
        }
    }

    cout << ans << '\n';
    cout << ans_cnt << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
