#include <iostream>
#include <vector>
#include <map>
#include <assert.h>
#include <set>
#include <algorithm>
#include <deque>

using namespace std;

bool banned[2000];

vector<bool> ok(int v, vector<vector<pair<int, int>>> &g) {
    vector<bool> vis(g.size(), false);
    deque<int> q{v};
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (auto [u, i] : g[v]) {
            if (banned[i]) continue;
            if (!vis[u]) {
                vis[u] = true;
                q.push_back(u);
            }
        }
    }
    return vis;
}

vector<int> ord;

void dfs(int v, vector<vector<pair<int, int>>> &g, vector<bool> &used) {
    used[v] = true;
    for (auto [u, i] : g[v]) {
        if (!used[u]) {
            dfs(u, g, used);
        }
    }
    ord.push_back(v);
}

void dfs1(int v, vector<vector<int>> &g, vector<int> &col, int c) {
    col[v] = c;
    for (int u : g[v]) {
        if (col[u] == -1) {
            dfs1(u, g, col, c);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, type;
    cin >> n >> m >> type;
    vector<vector<pair<int, int>>> g(n);
    vector<vector<int>> rg(n);
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        rg[v].push_back(u);
        g[u].push_back({ v, i });
        edges.push_back({ u, v });
    }
    vector<bool> used(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, g, used);
        }
    }
    reverse(ord.begin(), ord.end());
    vector<int> cmps(n, -1);
    int c = 0;
    for (int i : ord) {
        if (cmps[i] == -1) {
            dfs1(i, rg, cmps, c++);
        }
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        auto [u, v] = edges[i];
        if (cmps[u] != cmps[v]) {
            continue;
        }
        banned[i] = true;
        vector<bool> vis = ok(u, g);
        /*if (vis[v]) {
            ++ans;
        } else {
            banned[i] = false;
        }*/
        banned[i] = false;
        if (vis[v]) {
            banned[i] = false;
        } else {
            ++ans;
            g[v].push_back({ u, m });
            //cout << u << ' ' << v << endl;
        }
    }
    vector<vector<pair<int, int>>> gp(c);
    vector<pair<int, int>> edges1;
    for (int i = 0; i < m; ++i) {
        auto [u, v] = edges[i];
        if (cmps[u] != cmps[v]) {
            gp[cmps[u]].push_back({ cmps[v], i });
            edges1.push_back({ cmps[u], cmps[v] });
        }
    }
    fill(banned, banned + m, false);
    for (int i = 0; i < edges1.size(); ++i) {
        auto [u, v] = edges1[i];
        banned[i] = true;
        vector<bool> vis = ok(u, gp);
        if (vis[v]) {
            ++ans;
        } else {
            banned[i] = false;
        }
    }
    cout << ans << '\n';
    cout << -1 << '\n';
}
/*
 5 6
 1 2
 1 5
 2 3
 3 4
 3 5
 4 2
 */
