#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, bool>>> gr;

vector<int> st;
vector<int> t;
int timer = 0;
vector<int> comps;

void dfs(int v) {
    int tin = timer++;
    t[v] = tin;
    st.push_back(v);
    for (auto [to, is_on] : gr[v]) {
        if (!is_on) continue;
        if (t[to] == -1) {
            dfs(to);
            t[v] = min(t[v], t[to]);
        } else if (comps[to] == -1) {
            t[v] = min(t[v], t[to]);
        }
    }
    if (tin == t[v]) {
        int cc = v;
        for (int i = st.size() - 1; st[i] != v; --i) {
            cc = min(cc, st[i]);
        }
        while (st.back() != v) {
            comps[st.back()] = cc;
            st.pop_back();
        }
        comps[v] = cc;
        st.pop_back();
    }
}

void scc_colors() {
    st.clear();
    timer = 0;
    t.assign(gr.size(), -1);
    comps.assign(gr.size(), -1);
    for (int i = 0; i < gr.size(); ++i) {
        if (t[i] == -1) {
            dfs(i);
        }
    }
}

int main() {
    int n, m, type;
    cin >> n >> m >> type;
    gr.resize(n);
    vector<pair<pair<int, int>, pair<int, int>>> edges(m);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        gr[u].emplace_back(v, true);
        gr[v].emplace_back(u, false);
        edges[i] = {{u, gr[u].size() - 1}, {v, gr[v].size() - 1}};
    }

    scc_colors();
    auto initial = comps;

    assert(m <= 30); // bitmasks

    vector<int> can_reverse(1 << m);

    for (int reversed = 1; reversed < (1 << m); ++reversed) {
        if (reversed == 0) break;
        auto reverse = [&] {
            for (int i = 0; i < m; ++i) {
                if (reversed >> i & 1) {
                    swap(gr[edges[i].first.first][edges[i].first.second].second,
                         gr[edges[i].second.first][edges[i].second.second].second);
                }
            }
        };
        reverse();
        scc_colors();
        reverse();
        can_reverse[reversed] = (comps == initial);
    }

    vector<int> sum_over_subsets = can_reverse;
    for (int i = 0; i < m; ++i) {
        for (int mask = 0; mask < (1 << m); ++mask) {
            if (mask >> i & 1) {
                sum_over_subsets[mask] += sum_over_subsets[mask - (1 << i)];
            }
        }
    }

    int ans = 0;
    int cnt = 0;
    for (int erased = 0; erased < (1 << m); ++erased) {
        if (sum_over_subsets[erased] == 0) {
            int pop = __builtin_popcount(erased);
            if (pop > ans) {
                ans = pop;
                cnt = 0;
            }
            if (pop == ans) {
                cnt++;
            }
            ans = max(ans, __builtin_popcount(erased));
        }
    }
    cout << ans << '\n';
    cout << cnt << '\n';
}
