#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, bool>>> gr;

vector<int> st;
vector<int> t;
int timer = 0;
vector<int> comps;

void dfs(int v) {
    int tin = timer++;
    t[v] = tin;
    st.push_back(v);
    for (auto [to, is_on] : gr[v]) {
        if (!is_on) continue;
        if (t[to] == -1) {
            dfs(to);
            t[v] = min(t[v], t[to]);
        } else if (comps[to] == -1) {
            t[v] = min(t[v], t[to]);
        }
    }
    if (tin == t[v]) {
        int cc = v;
        for (int i = st.size() - 1; st[i] != v; --i) {
            cc = min(cc, st[i]);
        }
        while (st.back() != v) {
            comps[st.back()] = cc;
            st.pop_back();
        }
        comps[v] = cc;
        st.pop_back();
    }
}

void scc_colors() {
    st.clear();
    timer = 0;
    t.assign(gr.size(), -1);
    comps.assign(gr.size(), -1);
    for (int i = 0; i < gr.size(); ++i) {
        if (t[i] == -1) {
            dfs(i);
        }
    }
}

int main() {
    int n, m, type;
    cin >> n >> m >> type;
    gr.resize(n);
    vector<pair<pair<int, int>, pair<int, int>>> edges(m);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        gr[u].emplace_back(v, true);
        gr[v].emplace_back(u, false);
        edges[i] = {{u, gr[u].size() - 1}, {v, gr[v].size() - 1}};
    }

    scc_colors();
    auto initial = comps;

//    assert(m <= 30); // bitmasks

    int ans = 0;
    int cnt = 0;

    for (int erased = 1; erased < (1 << m); ++erased) {
        bool unique = true;
        for (int reversed = erased; ; reversed = (reversed - 1) & erased) {
            if (reversed == 0) break;
            auto reverse = [&] {
                for (int i = 0; i < m; ++i) {
                    if (reversed >> i & 1) {
                        swap(gr[edges[i].first.first][edges[i].first.second].second,
                             gr[edges[i].second.first][edges[i].second.second].second);
                    }
                }
            };
            reverse();
            scc_colors();
            reverse();
            if (comps == initial) {
                unique = false;
                break;
            }
        }
        if (unique) {
            int pop = __builtin_popcount(erased);
            if (pop > ans) {
                ans = pop;
                cnt = 0;
            }
            if (pop == ans) {
                cnt++;
            }
            ans = max(ans, __builtin_popcount(erased));
        }
    }

    cout << ans << '\n';
    cout << cnt << '\n';
}
