#include "bits/stdc++.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array

using namespace std;

using vi = vector<int>;
using ll = long long;
using vl = vector<ll>;

const int N = 2e3 + 5;
vector<pair<int, int>> g[N], gr[N];
bool ban[N];
int used[N];
int usedE[N];
int comp[N];

int T = 1;

void dfs(int v) {
    used[v] = T;
    for(auto &[u, i] : g[v]) {
        if (ban[i] || used[u] == T) continue;
        dfs(u);
    }
}

int split_comp(int n) {
    vi ts;
    auto dfs1 = [&] (auto &&self, int v) -> void {
        used[v] = T;
        for(auto &[u, i] : gr[v]) {
            if (used[u] == T) continue;
            self(self, u);
        }
        ts.push_back(v);
    };

    T++;
    for(int i = 1; i <= n; ++i) {
        if (used[i] != T) {
            dfs1(dfs1, i);
        }
    }
    reverse(all(ts));

    int c = 0;
    auto dfs2 = [&] (auto &&self, int v) -> void {
        comp[v] = c;
        for(auto &[u, i] : g[v]) {
            if (comp[u]) continue;
            self(self, u);
        }
    };

    for(auto &v : ts) {
        if (comp[v]) continue;
        c++;
        dfs2(dfs2, v);
    }

    return c;
}

void solve() {
    int n, m, type; cin >> n >> m >> type;

    vector<pair<int, int>> es;
    rep(i, m) {
        int u, v; cin >> u >> v;
        es.emplace_back(u, v);
        g[u].emplace_back(v, i);
        gr[v].emplace_back(u, i);
    }

    int c = split_comp(n);
    int ans = 0;
    rep(i, m) {
        auto [u, v] = es[i];

        if (comp[u] == comp[v]) {
            // u -> v
            ban[i] = true;
            T++;
            dfs(u);
            ban[i] = false;
            if (used[v] == T) continue;

            ans++;

            g[v].emplace_back(u, i);
        } else {
            ban[i] = true;
            T++;
            dfs(u);
            ban[i] = false;
            if (used[v] == T) {
                ans++;
                ban[i] = true;
            }
        }

    }
    cout << ans << '\n';
    cout << -1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
